Subject: Re: Fw:[Bug 70471] xfrm policy node will double unlink.

From: "Xianpeng Zhao" <[email-masked]>
Date: Wed, 19 Feb 2014 10:07:14 +0800

Hi Steffen,

      This problem is happened when running stress test; Very little chance can get this case.

      As you say, add a long time sleep in function xfrm_policy_bysel_ctx between __xfrm_policy_unlink and 
xfrm_policy_kill, will reproduce this issue manually. 

      About my patch, I am not sure it is OK, because after it patched, the issue had reproduced once, but after some days test recently, have not reproduced again. 

      But I can make sure when __xfrm_policy_unlink find the node had been removed, return NULL instead of delete again will fix this problem.

      What's your suggestions?

------------------
Best Regards
Xianpeng

------------------ Original ------------------
From:  "Steffen Klassert";<[email-masked]>;
Date:  Tue, Feb 18, 2014 04:37 PM
To:  "Xianpeng Zhao"<[email-masked]>; 
Cc:  "netdev"<[email-masked]>; "alan"<[email-masked]>; 
Subject:  Re: Fw:[Bug 70471] xfrm policy node will double unlink.

On Tue, Feb 18, 2014 at 10:55:57AM +0800, Xianpeng Zhao wrote:
> Hi Group,
>      I found a problem about xfrm policy.
> 
>      In corner case, xfrm policy node will be double unlinked from the list.
> 
>     The scenario like this:
>     In thread context, After removed the node from list, before remove the xfrm policy expire timer. At this point, a timer interrupt come, and call the run_timer_softirq to execute the xfrm_policy_timer to remove the expired policy node; because this policy node had already removed from list. this remove will cause the node double unlinked.

Good catch!

I wonder why I've never seen this. Do you have a reproducer for this bug?

Looks like it is sufficient to reinitialize the bydst hlist in
__xfrm_policy_unlink(). Then hlist_unhashed() will notice that
this policy is not linked.

Does the patch below help?

diff --git a/net/xfrm/xfrm_policy.c b/net/xfrm/xfrm_policy.c
index 121399d..225f439 100644
--- a/net/xfrm/xfrm_policy.c
+++ b/net/xfrm/xfrm_policy.c
@@ -1156,7 +1156,7 @@ static struct xfrm_policy *__xfrm_policy_unlink(struct xfrm_policy *pol,
 	if (hlist_unhashed(&pol->bydst))
 		return NULL;
 
-	hlist_del(&pol->bydst);
+	hlist_del_init(&pol->bydst);
 	hlist_del(&pol->byidx);
 	list_del(&pol->walk.all);
 	net->xfrm.policy_count[dir]--;
.